import { BigNumberish, ContractTransaction, ethers, Signer } from "ethers";
import { ERC20ForAssetGrouping } from "./types/ERC20ForAssetGrouping";
import { DecodedCall } from "./abiDecoderController";
export declare class ERC20Controller {
    private _erc20Address;
    private _signer;
    private _erc20Contract?;
    constructor(erc20Address: string, signerOrProvider: Signer | ethers.providers.ExternalProvider);
    private _getERC20Contract;
    /**Getters */
    getContract(): Promise<ERC20ForAssetGrouping>;
    balanceOf(address: string): Promise<BigNumberish>;
    getName(): Promise<string>;
    getSymbol(): Promise<string>;
    getChainId(): Promise<BigNumberish>;
    getGroupingContract(): Promise<string>;
    getTotalSupply(): Promise<BigNumberish>;
    getDecimals(): Promise<BigNumberish>;
    /** Setters */
    transfer(recipient: string, amount: string): Promise<ContractTransaction>;
    transferOwnership(newOwner: string): Promise<ContractTransaction>;
    setGroupingContract(address: string): Promise<ContractTransaction>;
    mint(receiver: string, amount: BigNumberish): Promise<ContractTransaction>;
    /** Helpers */
    static encodeCall(functionName: string, args?: any[]): string;
    static decodeCall(data: string): DecodedCall | null;
}
