import { ContractTransaction, ethers, Signer } from "ethers";
import { ERC20FactoryV10 } from "./types/ERC20FactoryV10";
import { DecodedCall } from "./abiDecoderController";
export declare class ERC20FactoryController {
    private _erc20FactoryAddress;
    private _signer;
    private _erc20FactoryContract?;
    constructor(erc20FactoryAddress: string, signerOrProvider: Signer | ethers.providers.ExternalProvider);
    static deployERC20FactoryContract(signer: Signer): Promise<[ERC20FactoryV10, string]>;
    private _getERC20FactoryContract;
    /** Getters */
    getContract(): Promise<ERC20FactoryV10>;
    getOwner(): Promise<string>;
    getTokens(): Promise<Array<string>>;
    deployERC20Contract(chainId: number, name: string, symbol: string): Promise<ContractTransaction>;
    /** Helpers */
    static encodeCall(functionName: string, args?: any[]): string;
    static decodeCall(data: string): DecodedCall | null;
}
